---
identifier: "SS-2016-003"
package_slug: "packagist/silverstripe/cms"
title: "Hostname, IP and Protocol Spoofing through HTTP Headers"
description: "In it's default configuration, SilverStripe trusts all originating IPs
  to include HTTP headers for Hostname, IP and Protocol. This enables reverse proxies
  to forward requests while still retaining the original request information. Trusted
  IPs can be limited via the `SS_TRUSTED_PROXY_IPS` constant. Even with this restriction
  in place, SilverStripe trusts a variety of HTTP headers due to different proxy notations
  (e.g. `X-Forwarded-For` vs. `Client-IP`). Unless a proxy explicitly unsets invalid
  HTTP headers from connecting clients, this can lead to spoofing requests being passed
  through trusted proxies. The impact of spoofed headers can include `Director::forceSSL()`
  not being enforced, SS_HTTPRequest->getIP() returning a wrong IP (disabling any
  IP restrictions), and spoofed hostnames circumventing any hostname-specific restrictions
  enforced in SilverStripe Controllers. Regardless on running a reverse proxy in your
  hosting infrastructure, please follow the instructions on Secure Coding: Request
  hostname forgery in order to opt-in to these protections. If your website is not
  behind a reverse proxy, you might already be protected if using Apache with mod_env
  enabled, and you have the following line in your .htaccess file: `SetEnv BlockUntrustedIPs
  true`."
date: "2016-02-24"
pubdate: "2016-02-24"
affected_range: ">=3.1.0-alpha,<3.1.17-stable||>=3.2.0-alpha,<3.2.2-stable
  ||>=3.3.0-alpha,<3.3.0-stable"
fixed_versions:
- "3.1.17"
- "3.2.2"
- "3.3.0"
affected_versions: "All versions starting from 3.1.0-alpha before 3.1.17, all versions
  starting from 3.2.0-alpha before 3.2.2, all versions starting from 3.3.0-alpha before
  3.3.0"
solution: "Upgrade to latest version."
urls:
- "http://www.silverstripe.org/download/security-releases/ss-2016-003/"
credit: "Patrick Nelson and Ingo Schommer"
uuid: "ace78468-2cc7-4ea2-b0ec-2d113f39cb7f"
